#include "tsp.h"

void dynamic_master(char algorithm) {
        register int i;
        unsigned int local_used=0;
        struct unused_city *queue, *tmp, *root;
        unsigned int from_last=0;
        unsigned char last_city=0;
        struct best_node {
                unsigned char city;
                struct unused_city *node;
                unsigned int length;
        }local_best;

        if(!(cur_path = (char*)calloc(cities,sizeof(char))))
                handle_error("memory allocation failed [dynamic_master]");
        if(!(full_best_path = (char*)calloc(cities,sizeof(char))))
                handle_error("memory allocation failed [dynamic_master]");
        if(!(calculated = (unsigned int**)malloc(cities * sizeof(unsigned int*))))
                handle_error("memory allocation failed [dynamic_master]");
        for(i=0; i<cities; i++)
                if(!(calculated[i] = (unsigned int*)calloc(1<<cities, sizeof(unsigned int))))
                        handle_error("memory allocation failed [dynamic_master : main array]");

        cur_length = 0;
        if( algorithm == DYNAMIC )
                printf("best pathlength was : %ld\n",(best_pathlength = dynamic_rec(0,local_used | 1)));
        else
                printf("best pathlength was : %ld\n",(best_pathlength = dynamic_rec2(0,local_used | 1)));

        queue = malloc(sizeof(struct unused_city));
        queue->prev = NULL;
        queue->city = 1;

        /* now we know best patlength, but we still have to               */
        /* calculate path from the main array, using optimality principle */
        /* it's actually the most complicated part of this algorithm      */

        /* first initialize linked list for unused cities */
        root = queue;
        for(i=2; i<cities; i++) {
                tmp = queue;
                queue = malloc(sizeof(struct unused_city));
                queue->city = i;
                queue->prev = tmp;
                tmp->next = queue;
                if( i == (cities-1) )
                        queue->next = NULL;
        }
        tmp = queue = root;
        printf("0 ");
        local_used |= 1;

        /* now start asking pathlengths from calculated array, starting with */
        /* the second level of nodes in tree, all the lengths in this level  */
        /* are compared and we will go on with the best one                  */

        for(i=1; i<cities; i++) {
                queue = tmp;
                local_best.length = UINT_MAX;
                while( queue != NULL ) {

                        if( last_city > queue->city )
                                from_last = main_edge_array[last_city][queue->city];
                        else
                                from_last = main_edge_array[queue->city][last_city];

                        if(from_last+calculated[queue->city][local_used^(1<<queue->city)]<local_best.length) {
                                local_best.length=calculated[queue->city][local_used^(1<<queue->city)] + \
                                                  from_last;
                                local_best.city = queue->city;
                                local_best.node = queue;
                        }

                        queue = queue->next;
                }
                /* add city to used mask */
                local_used ^= (1<<local_best.city);
                /* remove best node from linked list */
                if(i!=cities-1) {
                        if(local_best.node->prev == NULL) {
                                tmp = local_best.node->next;
                                local_best.node->next->prev = NULL;
                        }
                        else if(local_best.node->next == NULL)
                                local_best.node->prev->next = NULL;
                        else {
                                local_best.node->next->prev = local_best.node->prev;
                                local_best.node->prev->next = local_best.node->next;
                        }
                }
                last_city = local_best.city;
                printf("%u ",local_best.city);
        }
        printf("0\n");

}

unsigned int dynamic_rec(unsigned char cur_city, unsigned int used) {
        register int i;
        static int counter=0;
        unsigned int tmp = 0 , local_best= UINT_MAX;

        counter++;

        /* first check if we already have calculated this value */
        if( calculated[cur_city][used] ) {
                counter--;
                return(calculated[cur_city][used]);
        }

        /* if not then calculate it */
        for( i=1; i<cities; i++) {
                if(!(used & (1<<i)) )   {
                        if( i > cur_city )
                                tmp = dynamic_rec(i, used | (1<<i)) + main_edge_array[i][cur_city];
                        else
                                tmp = dynamic_rec(i, used | (1<<i)) + main_edge_array[cur_city][i];
                        if( tmp < local_best )
                                local_best = tmp;
                }
        }

        /* if this is the last city, then return pathlength back to starting point */
        if( counter == cities ) {
                counter--;
                return(main_edge_array[cur_city][0]);
        }

        counter--;
        calculated[cur_city][used] = local_best;
        return(local_best);
}

unsigned int dynamic_rec2(unsigned char cur_city, unsigned int used) {
        register int i;
        static int depth=0;
        unsigned int tmp = 0, local_best = UINT_MAX;
        static unsigned int cur_length = 0;
        unsigned int tmp_length, tmp_best;
        static char cut_flag=0;

        depth++;

        if( calculated[cur_city][used] ) {
                depth--;
                return(calculated[cur_city][used]);
        }


        tmp_best = best_possible;
        tmp_length = cur_length;

        for( i=1; i<cities; i++ ) {
                if(!(used & (1<<i))) {
                        best_possible = tmp_best;
                        cur_length = tmp_length;
                        best_possible -= best_array[cur_city];

                        if( i > cur_city )
                                tmp = main_edge_array[i][cur_city];
                        else
                                tmp = main_edge_array[cur_city][i];
                        cur_length += tmp;
#ifdef DEBUG
                        printf("%d -> %d : %d %d\n",cur_city,i,cur_length,best_possible);
#endif

#ifdef DEBUG
                        printf("cur + best : %u\n",cur_length + best_possible);
#endif
                        if( (cur_length + best_possible) < best_pathlength ) {
                                tmp += dynamic_rec2( i, used | (1<<i));
                                if( cut_flag == 1 ) {
#ifdef DEBUG
                                        printf("cut flag value 1->0\n");
#endif
                                        cut_flag = 0;
                                        continue;
                                }
#ifdef DEBUG
                                printf("tmp is %u & local_best is %u\n",tmp,local_best);
#endif
                                if(tmp < local_best)
                                        local_best = tmp;
                        }
                        else  {
#ifdef DEBUG
                                printf("CUT !\n");
                                fflush(stdout);
#endif
                        }
                }
        }
#ifdef DEBUG
        printf("local best %u @ depth %d\n",local_best,depth);
#endif
        best_possible = tmp_best;
        cur_length = tmp_length;

        if( depth == cities ) {
#ifdef DEBUG
                printf("WILL return %u\n",main_edge_array[cur_city][0]);
#endif
                depth--;
                return(main_edge_array[cur_city][0]);
        }

        /* we have cut everything, parent has to know about it */
        if( local_best == UINT_MAX ) {
#ifdef DEBUG
                printf("cut flag -> 1 @ depth %d\n",depth);
#endif
               depth--;
                cut_flag = 1;
                return(0);
        }

        depth--;
        calculated[cur_city][used] = local_best;
        return(local_best);
}

